//+------------------------------------------------------------------+
//|                      Universalny_Sound_indicator.mq4
//|                      Copyright  2011, lukas1 
//|     aka lukas1
//| :       
//|              ,
//|               .
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, lukas1"
#property link      "lukas1@ngs.ru"

#property indicator_separate_window
//---- indicator parameters
extern string __="MACD";//Name
extern double __1 = 0.0002;   //Level1
extern double __2 = 0.0;      //Level2
extern double __3 = -0.0002;  //Level3
extern string _Wave__1 = "alert.wav";   //wavefile1
extern string _Wave__2 = "alert.wav";   //wavefile2
extern string _Wave__3 = "alert.wav";   //wavefile3

/*    = +1;   
 = -1;        = 0; */
extern int    ____1 = 0;// 
extern int    ____2 = 0;// 
extern int    ____3 = 0;// 

#property indicator_color1 Silver
#property indicator_width1 2
//---- indicator buffers
double Buffer2[];
//----
int br1=0,br2=0,br3=0;
string ticker;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {ticker=StringTrimRight(StringTrimLeft(__));
   IndicatorBuffers (1);
   IndicatorDigits (Digits);
   IndicatorShortName("UniSound ("+ticker+")");

   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,Buffer2);

//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
   {int limit;
    int counted_bars = IndicatorCounted();
//---- check for possible errors
    if(counted_bars < 0) 
        return(-1);
//---- last counted bar will be recounted
    if(counted_bars > 0) 
        counted_bars--;
    limit = Bars - counted_bars;
    if(counted_bars==0) limit--;
//----
    for(int i = limit; i >=0; i--)
       {
        Buffer2[i]=iCustom(Symbol(),0, ticker, 0,i);
       }
    signal(__1,_Wave__1,
            ____1, br1);
    br1=Bars;
    signal(__2,_Wave__2,
            ____2, br2);
    br2=Bars;
    signal(__3,_Wave__3,
            ____3, br3);
    br3=Bars;
   return(0);
   }
//+------------------------------------------------------------------+
void signal(double level, string wave, int moving, int bari) {
    if( (Buffer2[2]<level && 
         Buffer2[1]>level ) &&
        (moving==1 || moving==0)&&
       bari<Bars )
      {Alert(" ",Symbol()," ",Period()," \"",
             __, 
             "\"    ",DoubleToStr(level,Digits));
       PlaySound(wave); 
       bari=Bars;
      }
   if( (Buffer2[2]>level && 
        Buffer2[1]<level ) &&
       (moving==-1 || moving==0) &&
       bari<Bars )
     {Alert(" ",Symbol()," ",Period()," \"",
             __, 
             "\"    ",DoubleToStr(level,Digits));
      PlaySound(wave); 
      bari=Bars;
     }
      
  }
//+------------------------------------------------------------------+

